| AttributeCertificate | Contents | Index
Codec.ASN1.BER |
Portability | portable
Stability | experimental
Maintainer | dominic.steinitz@blueyonder.co.uk
Contents
Types Type classes Function types
Description
Typecheck and decode BER representations as produced by Codec.ASN1.TLV
Synopsis
data Encoding
= Primitive TagType TagValue Length PrimitiveValue
| Constructed TagType TagValue Length [Encoding]
data Defaulted
= DefPrim TagType TagValue Length PrimitiveValue
| DefCons TagType TagValue Length [Maybe Defaulted]
type Length = Integer
class Encode a where
decode :: AbstractType -> Maybe Defaulted -> Maybe a
encodedComponents :: Encoding -> [Encoding]
encodedDefComps :: Defaulted -> [Maybe Defaulted]
defaultedTagValue :: Defaulted -> TagValue
typeCheck :: TypeDefn -> Encoding -> IO (TypeDefn, Defaulted)
replaceRef :: AbstractType -> [AbstractType] -> [Maybe Defaulted] -> AbstractType
Types
data Encoding
Constructors
Primitive TagType TagValue Length PrimitiveValue |
Constructed TagType TagValue Length [Encoding] |
Instances
Eq Encoding
Show Encoding
data Defaulted
Constructors
DefPrim TagType TagValue Length PrimitiveValue |
DefCons TagType TagValue Length [Maybe Defaulted] |
Instances
Eq Defaulted
Show Defaulted
type Length = Integer
Type classes
class Encode a where
Methods
decode :: AbstractType -> Maybe Defaulted -> Maybe a
Instances
Encode AlgorithmIdentifier
Encode AttCertIssuer
Encode AttCertValidityPeriod
Encode Attribute
Encode AttributeCertificate
Encode AttributeCertificateInfo
Encode AttributeTypeAndValue
Encode AttributeValue
Encode BitString
Encode Bool
Encode Certificate
Encode CertificateVersion
Encode DirectoryString
Encode GeneralName
Encode GeneralNames
Encode GeneralizedTime
Encode Holder
Encode HolderGeneralNames
Encode IA5String
Encode Integer
Encode IssuerSerial
Encode Name
Encode Name
Encode OID
Encode OctetString
Encode PrintableString
Encode RDNSequence
Encode RSAPublicKey
Encode RelativeDistinguishedName
Encode SignedCertificate
Encode SubjectPublicKeyInfo
Encode Time
Encode Validity
Encode VisibleString
Encode a => Encode (SetOf a)
Encode a => Encode [a]
Function types
encodedComponents :: Encoding -> [Encoding]
encodedDefComps :: Defaulted -> [Maybe Defaulted]
defaultedTagValue :: Defaulted -> TagValue
typeCheck :: TypeDefn -> Encoding -> IO (TypeDefn, Defaulted)
Type check the abstract representation of a Tag Length Value against an ASN.1 type definition.
replaceRef :: AbstractType -> [AbstractType] -> [Maybe Defaulted] -> AbstractType
Produced by Haddock version 0.8